"{ Package: 'jv:calipel/s/stx' }"

StandaloneStartup subclass:#BenchmarkRunnerAdapterStX
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Smalltalk/X'
!

BenchmarkRunnerAdapterStX class instanceVariableNames:'runner'

"
 The following class instance variables are inherited by this class:

	StandaloneStartup - MutexHandle
	Object - 
"
!


!BenchmarkRunnerAdapterStX class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    runner := BenchmarkRunner new.

    "Modified: / 06-06-2013 / 11:25:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkRunnerAdapterStX class methodsFor:'defaults'!

allowDebugOption

    ^true

    "Created: / 21-07-2011 / 09:48:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkRunnerAdapterStX class methodsFor:'error handling'!

error: message
    ^ runner error: message

    "Created: / 06-06-2013 / 11:22:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

exit: status
    ^ runner exit: status

    "Created: / 06-06-2013 / 11:23:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkRunnerAdapterStX class methodsFor:'multiple applications support'!

applicationRegistryPath
    "the key under which this application stores its process ID in the registry
     as a collection of path-components.
     i.e. if #('foo' 'bar' 'baz') is returned here, the current applications ID will be stored
     in HKEY_CURRENT_USER\Software\foo\bar\baz\CurrentID.
     (would also be used as a relative path for a temporary lock file under unix).
     Used to detect if another instance of this application is already running."

    ^ #('jv' 'calipel' 's')

    "Modified: / 28-05-2013 / 13:02:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

applicationUUID
    "answer an application-specific unique uuid.
     This is used as the name of some exclusive OS-resource, which is used to find out,
     if another instance of this application is already running.
     Under win32, a mutex is used; under unix, an exclusive file in the tempDir could be used.
     If redefined, please return a real UUID (i.e. UUID fromString:'.....') and not a string or
     similar possibly conflicting identifier.
     You can paste a fresh worldwide unique id via the editor's more-misc-paste UUID menuFunction."

    ^ UUID fromString: 'a7f3d0c5-429c-4be8-b857-4ff6ba6b0b65'

    "Modified: / 28-05-2013 / 13:02:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkRunnerAdapterStX class methodsFor:'startup'!

setupToolsForDebug

    super setupToolsForDebug.
    runner debugging: true

    "Created: / 06-11-2011 / 22:06:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 06-06-2013 / 09:25:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

usage
    "Print usage to stderr"

    Stderr  nextPutAll:  'usage: benchmark-runner.';
            nextPutAll: (OperatingSystem isMSWINDOWSlike ifTrue:['bat'] ifFalse:['sh']);
            nextPutAll: ' <options> suitespec1 [suitespec2 [suitespec3 [...]]]';
            cr; cr.
    Stderr nextPutLine: 'Smalltalk/X specific options:'.
    Stderr nextPutLine: '  --debug ................ run in debug mode (only for Smalltalk/X)'.
    Stderr nextPutLine: '  -p PACKAGE ............. load package PACKAGE before running tests'.
    Stderr cr.
    runner options

    "Created: / 13-01-2012 / 11:48:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 06-06-2013 / 11:09:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkRunnerAdapterStX class methodsFor:'startup-to be redefined'!

main:argv0
    | argv i packages |    

    packages := OrderedCollection new.
    argv := argv0 asOrderedCollection.
    i := 1.
    [ i <= argv size ] whileTrue:[
        | arg |

        arg := argv0 at: i.
        arg = '-p' ifTrue:[
            i == argv size ifTrue:[
                self error: '-p expects package name'.
            ] ifFalse:[
                packages add: (argv at: i + 1).
                argv removeIndex: i; removeIndex: i + 1.
                i := i - 2.
            ]
        ].
        i := i + 1.
    ].

    "/Load packages..."
    packages isEmpty ifTrue:[packages add: (BenchmarkInstance package , '/benchmarks')].
    packages do:[:each|
        (Smalltalk loadPackage: each) ifFalse:[
            self error: 'Failed to load package ''', each ,''''.
            self exit: 2.
        ]
    ].

    runner main: argv

    "Created: / 06-06-2013 / 10:07:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 06-06-2013 / 11:23:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkRunnerAdapterStX class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !


BenchmarkRunnerAdapterStX initialize!
